Merge "Refactor lf-c-cpp-jobs for common anchor"
[releng/global-jjb.git] / shell / job-cost.sh
1 #!/bin/bash
2 # SPDX-License-Identifier: EPL-1.0
3 ##############################################################################
4 # Copyright (c) 2019 The Linux Foundation and others.
5 #
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Eclipse Public License v1.0
8 # which accompanies this distribution, and is available at
9 # http://www.eclipse.org/legal/epl-v10.html
10 ##############################################################################
11 echo "---> job-cost.sh"
12
13 set -euf -o pipefail
14
15 # shellcheck disable=SC1090
16 source ~/lf-env.sh
17
18 # AWS job cost not supported, exit
19 if grep -qi amazon /sys/devices/virtual/dmi/id/bios_vendor ; then
20   echo "INFO: Not able to calculate job cost on AWS"
21   exit 0
22 fi
23
24 lf-activate-venv zipp==1.1.0 python-openstackclient
25
26 if [[ -z ${JOB_NAME:-} ]]; then
27     lf-echo-error "Required Env Variable Unset/Empty: JOB_NAME"
28     exit 1
29 fi
30
31 # Get the cost of the Openstack agents. The 'stack-cost' file is created when
32 # the 'lftools openstack stack cost' command is called from
33 # 'openstack-stack-delete.sh' script. The 'stack-cost' file will only be created
34 # if this is an openstack job.
35 if [[ -f stack-cost ]]; then
36     echo "DEBUG: $(cat stack-cost)"
37     echo "INFO: Retrieving Stack Cost..."
38     if ! stack_cost=$(grep -F "total: " stack-cost | awk '{print $2}'); then
39         echo "ERROR: Unable to retrieve Stack Cost, continuing anyway"
40         stack_cost=0
41     fi
42 else
43     echo "INFO: No Stack..."
44     stack_cost=0
45 fi
46
47 # Retrieve the current uptime (in seconds)
48 uptime=$(awk '{print $1}' /proc/uptime)
49 # Convert to integer by truncating fractional part' and round up by one
50 ((uptime=${uptime%\.*}+1))
51
52 # EC2 and OpenStack have simiar instace metadata APIs at this IP
53 # AWS docs: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html
54 # Nova docs: https://docs.openstack.org/nova/latest/user/metadata.html
55 instance_type=$(curl -s http://169.254.169.254/latest/meta-data/instance-type)
56
57 echo "INFO: Retrieving Pricing Info for: $instance_type"
58 url="https://pricing.vexxhost.net/v1/pricing/$instance_type/cost?seconds=$uptime"
59 json_block=$(curl -s "$url")
60
61 # check if JSON returned and can be parsed
62 if jq . <<< "$json_block" > /dev/null 2>&1; then
63     cost=$(jq .cost <<< "$json_block")
64     resource=$(jq .resource <<< "$json_block" | tr -d '"')
65 else
66     echo "ERROR: Pricing API returned invalid json"
67     cost=0
68     resource='unknown'
69 fi
70
71 # Archive the cost date
72 mkdir -p "$WORKSPACE/archives/cost"
73
74 echo "INFO: Archiving Costs"
75
76 # Set the timestamp in GMT
77 # This format is readable by spreadsheet and is easily sortable
78 date=$(TZ=GMT date +'%Y-%m-%d %H:%M:%S')
79
80 # Format the uptime, cost & stack_cost fields
81 printf "%s,%s,%s,%s,%d,%.2f,%.2f\n" "$JOB_NAME" "$BUILD_NUMBER" "$date" \
82        "$resource" "$uptime" "$cost" "$stack_cost" > "$WORKSPACE/archives/cost.csv"